Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit/src/Dependency_checking_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit/src/Dependency_checking_unit_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit/src/Dependency_checking_unit_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Dependency_checking_unit/include/Dependency_checking_unit.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -29,51 +30,47 @@
 	delete     in_NRESET;
 
-// 	delete []  in_RENAME_IN_VAL                ;
-// 	delete [] out_RENAME_IN_ACK                ;
-	if (_param->_have_port_front_end_id)
-	delete []  in_RENAME_IN_FRONT_END_ID       ;
-	if (_param->_have_port_context_id)
-	delete []  in_RENAME_IN_CONTEXT_ID         ;
-	delete []  in_RENAME_IN_READ_RA            ;
-	delete []  in_RENAME_IN_NUM_REG_RA_LOG     ;
-	delete []  in_RENAME_IN_NUM_REG_RA_PHY     ;
-	delete []  in_RENAME_IN_READ_RB            ;
-	delete []  in_RENAME_IN_NUM_REG_RB_LOG     ;
-	delete []  in_RENAME_IN_NUM_REG_RB_PHY     ;
-	delete []  in_RENAME_IN_READ_RC            ;
-	delete []  in_RENAME_IN_NUM_REG_RC_LOG     ;
-	delete []  in_RENAME_IN_NUM_REG_RC_PHY     ;
-	delete []  in_RENAME_IN_WRITE_RD           ;
-	delete []  in_RENAME_IN_NUM_REG_RD_LOG     ;
-	delete []  in_RENAME_IN_NUM_REG_RD_PHY_OLD ;
-	delete []  in_RENAME_IN_NUM_REG_RD_PHY_NEW ;
-	delete []  in_RENAME_IN_WRITE_RE           ;
-	delete []  in_RENAME_IN_NUM_REG_RE_LOG     ;
-	delete []  in_RENAME_IN_NUM_REG_RE_PHY_OLD ;
-	delete []  in_RENAME_IN_NUM_REG_RE_PHY_NEW ;
+//      DELETE1_SIGNAL( in_RENAME_IN_VAL                ,_param->_nb_inst_insert,1);
+//      DELETE1_SIGNAL(out_RENAME_IN_ACK                ,_param->_nb_inst_insert,1);
+        DELETE1_SIGNAL( in_RENAME_IN_FRONT_END_ID       ,_param->_nb_inst_insert,_param->_size_front_end_id          );
+        DELETE1_SIGNAL( in_RENAME_IN_CONTEXT_ID         ,_param->_nb_inst_insert,_param->_size_context_id            );
+        DELETE1_SIGNAL( in_RENAME_IN_READ_RA            ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RA_LOG     ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RA_PHY     ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_READ_RB            ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RB_LOG     ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RB_PHY     ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_READ_RC            ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RC_LOG     ,_param->_nb_inst_insert,_param->_size_special_register_logic);
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RC_PHY     ,_param->_nb_inst_insert,_param->_size_special_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_WRITE_RD           ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RD_LOG     ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RD_PHY_OLD ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RD_PHY_NEW ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_WRITE_RE           ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RE_LOG     ,_param->_nb_inst_insert,_param->_size_special_register_logic);
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RE_PHY_OLD ,_param->_nb_inst_insert,_param->_size_special_register      );
+        DELETE1_SIGNAL( in_RENAME_IN_NUM_REG_RE_PHY_NEW ,_param->_nb_inst_insert,_param->_size_special_register      );
 
-// 	delete [] out_RENAME_OUT_VAL               ;
-// 	delete []  in_RENAME_OUT_ACK               ;
-	if (_param->_have_port_front_end_id)
-	delete [] out_RENAME_OUT_FRONT_END_ID      ;
-	if (_param->_have_port_context_id)
-	delete [] out_RENAME_OUT_CONTEXT_ID        ;
-	delete [] out_RENAME_OUT_READ_RA           ;
-	delete [] out_RENAME_OUT_NUM_REG_RA_LOG    ;
-	delete [] out_RENAME_OUT_NUM_REG_RA_PHY    ;
-	delete [] out_RENAME_OUT_READ_RB           ;
-	delete [] out_RENAME_OUT_NUM_REG_RB_LOG    ;
-	delete [] out_RENAME_OUT_NUM_REG_RB_PHY    ;
-	delete [] out_RENAME_OUT_READ_RC           ;
-	delete [] out_RENAME_OUT_NUM_REG_RC_LOG    ;
-	delete [] out_RENAME_OUT_NUM_REG_RC_PHY    ;
-	delete [] out_RENAME_OUT_WRITE_RD          ;
-	delete [] out_RENAME_OUT_NUM_REG_RD_LOG    ;
-	delete [] out_RENAME_OUT_NUM_REG_RD_PHY_OLD;
-	delete [] out_RENAME_OUT_NUM_REG_RD_PHY_NEW;
-	delete [] out_RENAME_OUT_WRITE_RE          ;
-	delete [] out_RENAME_OUT_NUM_REG_RE_LOG    ;
-	delete [] out_RENAME_OUT_NUM_REG_RE_PHY_OLD;
-	delete [] out_RENAME_OUT_NUM_REG_RE_PHY_NEW;
+//      DELETE1_SIGNAL(out_RENAME_OUT_VAL               ,_param->_nb_inst_insert,1);
+//      DELETE1_SIGNAL( in_RENAME_OUT_ACK               ,_param->_nb_inst_insert,1);
+        DELETE1_SIGNAL(out_RENAME_OUT_FRONT_END_ID      ,_param->_nb_inst_insert,_param->_size_front_end_id          );
+        DELETE1_SIGNAL(out_RENAME_OUT_CONTEXT_ID        ,_param->_nb_inst_insert,_param->_size_context_id            );
+        DELETE1_SIGNAL(out_RENAME_OUT_READ_RA           ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RA_LOG    ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RA_PHY    ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_READ_RB           ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RB_LOG    ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RB_PHY    ,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_READ_RC           ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RC_LOG    ,_param->_nb_inst_insert,_param->_size_special_register_logic);
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RC_PHY    ,_param->_nb_inst_insert,_param->_size_special_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_WRITE_RD          ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RD_LOG    ,_param->_nb_inst_insert,_param->_size_general_register_logic);
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RD_PHY_OLD,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RD_PHY_NEW,_param->_nb_inst_insert,_param->_size_general_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_WRITE_RE          ,_param->_nb_inst_insert,1                                   );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RE_LOG    ,_param->_nb_inst_insert,_param->_size_special_register_logic);
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RE_PHY_OLD,_param->_nb_inst_insert,_param->_size_special_register      );
+        DELETE1_SIGNAL(out_RENAME_OUT_NUM_REG_RE_PHY_NEW,_param->_nb_inst_insert,_param->_size_special_register      );
       }
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_allocation.cpp	(revision 112)
@@ -49,5 +49,5 @@
 							 ,IN
 							 ,SOUTH,
-							 "Generalist interface"
+							 _("Generalist interface")
 #endif
 							 );
@@ -58,5 +58,5 @@
     // ~~~~~[ interface : "pop" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("pop", IN, NORTH, "New destination register", _param->_nb_pop);
+       ALLOC1_INTERFACE_BEGIN("pop", IN, NORTH, _("New destination register"), _param->_nb_pop);
 
        ALLOC1_VALACK_IN ( in_POP_VAL        ,VAL);
@@ -66,38 +66,45 @@
        ALLOC1_SIGNAL_IN ( in_POP_SPR_VAL    ,"spr_val"    ,Tcontrol_t        ,1                             );
        ALLOC1_SIGNAL_OUT(out_POP_SPR_NUM_REG,"spr_num_reg",Tspecial_address_t,_param->_size_special_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_pop);
      }
 
     // ~~~~~[ interface : "push_gpr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("push_gpr", IN, NORTH, "General register free", _param->_nb_push);
+       ALLOC1_INTERFACE_BEGIN("push_gpr", IN, NORTH, _("General register free"), _param->_nb_push);
 
        ALLOC1_VALACK_IN ( in_PUSH_GPR_VAL    ,VAL);
        ALLOC1_VALACK_OUT(out_PUSH_GPR_ACK    ,ACK);
        ALLOC1_SIGNAL_IN ( in_PUSH_GPR_NUM_REG,"num_reg",Tgeneral_address_t,_param->_size_general_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_push);
      }
 
     // ~~~~~[ interface : "push_spr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("push_spr", IN, NORTH, "General register free", _param->_nb_push);
+       ALLOC1_INTERFACE_BEGIN("push_spr", IN, NORTH, _("General register free"), _param->_nb_push);
 
        ALLOC1_VALACK_IN ( in_PUSH_SPR_VAL    ,VAL);
        ALLOC1_VALACK_OUT(out_PUSH_SPR_ACK    ,ACK);
        ALLOC1_SIGNAL_IN ( in_PUSH_SPR_NUM_REG,"num_reg",Tspecial_address_t,_param->_size_special_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_push);
      }
 
      if (usage_is_set(_usage,USE_SYSTEMC))
        {
-     _gpr_list = new std::list<uint32_t> [_param->_nb_bank];
-     _spr_list = new std::list<uint32_t> [_param->_nb_bank];
+     ALLOC1(_gpr_list,std::list<uint32_t>,_param->_nb_bank);
+     ALLOC1(_spr_list,std::list<uint32_t>,_param->_nb_bank);
 
-     internal_POP_ACK       = new Tcontrol_t [_param->_nb_pop];
-     internal_POP_GPR_BANK  = new uint32_t   [_param->_nb_pop];
-     internal_POP_SPR_BANK  = new uint32_t   [_param->_nb_pop];
+     ALLOC1(internal_POP_ACK      ,Tcontrol_t,_param->_nb_pop);
+     ALLOC1(internal_POP_GPR_BANK ,uint32_t  ,_param->_nb_pop);
+     ALLOC1(internal_POP_SPR_BANK ,uint32_t  ,_param->_nb_pop);
 
-     internal_PUSH_GPR_ACK  = new Tcontrol_t [_param->_nb_push];
-     internal_PUSH_SPR_ACK  = new Tcontrol_t [_param->_nb_push];
-     internal_PUSH_GPR_BANK = new uint32_t   [_param->_nb_push];
-     internal_PUSH_SPR_BANK = new uint32_t   [_param->_nb_push];
+     ALLOC1(internal_PUSH_GPR_ACK ,Tcontrol_t,_param->_nb_push);
+     ALLOC1(internal_PUSH_SPR_ACK ,Tcontrol_t,_param->_nb_push);
+     ALLOC1(internal_PUSH_GPR_BANK,uint32_t  ,_param->_nb_push);
+     ALLOC1(internal_PUSH_SPR_BANK,uint32_t  ,_param->_nb_push);
        }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     _priority_gpr = new generic::priority::Priority (_name+"_priority_gpr",
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/include/Free_List_unit.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -29,30 +30,30 @@
 	delete    in_NRESET;
 
-	delete []  in_POP_VAL        ;
-	delete [] out_POP_ACK        ;
-	delete []  in_POP_GPR_VAL    ;
-	delete [] out_POP_GPR_NUM_REG;
-	delete []  in_POP_SPR_VAL    ;
-	delete [] out_POP_SPR_NUM_REG;
+        DELETE1_SIGNAL( in_POP_VAL         ,_param->_nb_pop,1);
+        DELETE1_SIGNAL(out_POP_ACK         ,_param->_nb_pop,1);
+        DELETE1_SIGNAL( in_POP_GPR_VAL     ,_param->_nb_pop,1                             );
+        DELETE1_SIGNAL(out_POP_GPR_NUM_REG ,_param->_nb_pop,_param->_size_general_register);
+        DELETE1_SIGNAL( in_POP_SPR_VAL     ,_param->_nb_pop,1                             );
+        DELETE1_SIGNAL(out_POP_SPR_NUM_REG ,_param->_nb_pop,_param->_size_special_register);
 
-	delete []  in_PUSH_GPR_VAL    ;
-	delete [] out_PUSH_GPR_ACK    ;
-	delete []  in_PUSH_GPR_NUM_REG;
+        DELETE1_SIGNAL( in_PUSH_GPR_VAL    ,_param->_nb_push,1);
+        DELETE1_SIGNAL(out_PUSH_GPR_ACK    ,_param->_nb_push,1);
+        DELETE1_SIGNAL( in_PUSH_GPR_NUM_REG,_param->_nb_push,_param->_size_general_register);
 
-	delete []  in_PUSH_SPR_VAL    ;
-	delete [] out_PUSH_SPR_ACK    ;
-	delete []  in_PUSH_SPR_NUM_REG;
+        DELETE1_SIGNAL( in_PUSH_SPR_VAL    ,_param->_nb_push,1);
+        DELETE1_SIGNAL(out_PUSH_SPR_ACK    ,_param->_nb_push,1);
+        DELETE1_SIGNAL( in_PUSH_SPR_NUM_REG,_param->_nb_push,_param->_size_special_register);
 
-        delete [] _gpr_list;
-        delete [] _spr_list;
-        
-        delete [] internal_POP_ACK     ;
-        delete [] internal_POP_GPR_BANK;
-        delete [] internal_POP_SPR_BANK;
-        
-        delete [] internal_PUSH_GPR_ACK ;
-        delete [] internal_PUSH_SPR_ACK ;
-        delete [] internal_PUSH_GPR_BANK;
-        delete [] internal_PUSH_SPR_BANK;
+        DELETE1(_gpr_list             ,_param->_nb_bank);
+        DELETE1(_spr_list             ,_param->_nb_bank);
+
+        DELETE1(internal_POP_ACK      ,_param->_nb_pop);
+        DELETE1(internal_POP_GPR_BANK ,_param->_nb_pop);
+        DELETE1(internal_POP_SPR_BANK ,_param->_nb_pop);
+
+        DELETE1(internal_PUSH_GPR_ACK ,_param->_nb_push);
+        DELETE1(internal_PUSH_SPR_ACK ,_param->_nb_push);
+        DELETE1(internal_PUSH_GPR_BANK,_param->_nb_push);
+        DELETE1(internal_PUSH_SPR_BANK,_param->_nb_push);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_transition.cpp	(revision 112)
@@ -51,5 +51,6 @@
 
 #ifdef STATISTICS
-              (*_stat_nb_inst_pop) ++;
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*_stat_nb_inst_pop) ++;
 #endif
 
@@ -57,5 +58,6 @@
                 {
 #ifdef STATISTICS
-                  (*_stat_nb_inst_pop_gpr) ++;
+                  if (usage_is_set(_usage,USE_STATISTICS))
+                    (*_stat_nb_inst_pop_gpr) ++;
 #endif
                   _gpr_list [internal_POP_GPR_BANK[i]].pop_front();
@@ -65,5 +67,6 @@
                 {
 #ifdef STATISTICS
-                  (*_stat_nb_inst_pop_spr) ++;
+                  if (usage_is_set(_usage,USE_STATISTICS))
+                    (*_stat_nb_inst_pop_spr) ++;
 #endif
                   _spr_list [internal_POP_SPR_BANK[i]].pop_front();
@@ -82,5 +85,6 @@
 
 #ifdef STATISTICS
-              (*_stat_nb_inst_push_gpr) ++;
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*_stat_nb_inst_push_gpr) ++;
 #endif
 
@@ -98,5 +102,6 @@
 
 #ifdef STATISTICS
-              (*_stat_nb_inst_push_spr) ++;
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*_stat_nb_inst_push_spr) ++;
 #endif
 
@@ -105,6 +110,8 @@
 
 #ifdef STATISTICS
-          for (uint32_t i=0; i<_param->_nb_bank; ++i)
-            {
+        if (usage_is_set(_usage,USE_STATISTICS))
+          for (uint32_t i=0; i<_param->_nb_bank; ++i)
+            {
+              
               (*(_stat_bank_gpr_nb_elt [i])) += _gpr_list[i].size();
               (*(_stat_bank_spr_nb_elt [i])) += _spr_list[i].size();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp	(revision 112)
@@ -89,4 +89,5 @@
   ALLOC1_SC_SIGNAL(out_RETIRE_RESTORE_RD_PHY_OLD,"out_RETIRE_RESTORE_RD_PHY_OLD",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL(out_RETIRE_RESTORE_RE_PHY_OLD,"out_RETIRE_RESTORE_RE_PHY_OLD",Tcontrol_t        ,_param->_nb_inst_retire);
+  ALLOC1_SC_SIGNAL(out_RETIRE_RESTORE           ,"out_RETIRE_RESTORE           ",Tcontrol_t        ,_param->_nb_inst_retire);
 
   ALLOC2_SC_SIGNAL( in_RETIRE_EVENT_VAL         ," in_RETIRE_EVENT_VAL         ",Tcontrol_t        ,_param->_nb_front_end,_param->_nb_context[it1]);
@@ -147,4 +148,5 @@
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit,out_RETIRE_RESTORE_RD_PHY_OLD,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit,out_RETIRE_RESTORE_RE_PHY_OLD,_param->_nb_inst_retire);
+  INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit,out_RETIRE_RESTORE           ,_param->_nb_inst_retire);
 
   INSTANCE2_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_EVENT_VAL         ,_param->_nb_front_end, _param->_nb_context[it1]);
@@ -540,4 +542,5 @@
   delete [] out_RETIRE_RESTORE_RD_PHY_OLD;
   delete [] out_RETIRE_RESTORE_RE_PHY_OLD;
+  delete [] out_RETIRE_RESTORE           ;
 
   DELETE2_SC_SIGNAL( in_RETIRE_EVENT_VAL            ,_param->_nb_front_end, _param->_nb_context[it1]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/include/Register_Address_Translation_unit.h	(revision 112)
@@ -104,4 +104,5 @@
   public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE_RD_PHY_OLD;//[nb_inst_retire]
   public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE_RE_PHY_OLD;//[nb_inst_retire]
+  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_RESTORE           ;//[nb_inst_retire]
 
     // ~~~~~[ Interface "retire_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -126,4 +127,7 @@
   private   : bool                        *** internal_rat_gpr_update_table;         //[nb_front_end][nb_context][nb_general_register_logic]
   private   : bool                        *** internal_rat_spr_update_table;         //[nb_front_end][nb_context][nb_special_register_logic]
+  public    : Tcontrol_t                    * internal_RETIRE_RESTORE_RD_PHY_OLD;//[nb_inst_retire]
+  public    : Tcontrol_t                    * internal_RETIRE_RESTORE_RE_PHY_OLD;//[nb_inst_retire]
+
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_allocation.cpp	(revision 112)
@@ -59,5 +59,5 @@
     // ~~~~~[ Interface "rename" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("rename",IN,EAST,"Input to rename source logical register", _param->_nb_inst_insert);
+      ALLOC1_INTERFACE_BEGIN("rename",IN,EAST,_("Input to rename source logical register"), _param->_nb_inst_insert);
 
       ALLOC1_VALACK_IN ( in_RENAME_VAL               , VAL);
@@ -75,9 +75,11 @@
       ALLOC1_SIGNAL_OUT(out_RENAME_NUM_REG_RD_PHY_OLD,"num_reg_rd_phy_old",Tgeneral_address_t,_param->_size_general_register);
       ALLOC1_SIGNAL_OUT(out_RENAME_NUM_REG_RE_PHY_OLD,"num_reg_re_phy_old",Tspecial_address_t,_param->_size_special_register);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_insert);
     }
     
     // ~~~~~[ Interface "insert" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("insert",IN,NORTH,"Input to rename destination logical register", _param->_nb_inst_insert);
+      ALLOC1_INTERFACE_BEGIN("insert",IN,NORTH,_("Input to rename destination logical register"), _param->_nb_inst_insert);
       
       ALLOC1_VALACK_IN ( in_INSERT_VAL           ,VAL);
@@ -91,9 +93,11 @@
       ALLOC1_SIGNAL_IN ( in_INSERT_NUM_REG_RD_PHY,"num_reg_rd_phy",Tgeneral_address_t,_param->_size_general_register);
       ALLOC1_SIGNAL_IN ( in_INSERT_NUM_REG_RE_PHY,"num_reg_re_phy",Tspecial_address_t,_param->_size_special_register);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_insert);
     }
     
     // ~~~~~[ Interface "retire" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("retire",IN,NORTH,"Input to update on event", _param->_nb_inst_retire);
+      ALLOC1_INTERFACE_BEGIN("retire",IN,NORTH,_("Input to update on event"), _param->_nb_inst_retire);
 
       ALLOC1_VALACK_IN ( in_RETIRE_VAL               ,VAL);
@@ -109,13 +113,18 @@
       ALLOC1_SIGNAL_OUT(out_RETIRE_RESTORE_RD_PHY_OLD,"restore_rd_phy_old",Tcontrol_t        ,1);
       ALLOC1_SIGNAL_OUT(out_RETIRE_RESTORE_RE_PHY_OLD,"restore_re_phy_old",Tcontrol_t        ,1);
+      ALLOC1_SIGNAL_OUT(out_RETIRE_RESTORE           ,"restore"           ,Tcontrol_t        ,1);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_retire);
     }
 
     // ~~~~~[ Interface : "retire_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC2_INTERFACE("retire_event", IN,NORTH, _("Retire event"), _param->_nb_front_end, _param->_nb_context[it1]);
+      ALLOC2_INTERFACE_BEGIN("retire_event", IN,NORTH, _("Retire event"), _param->_nb_front_end, _param->_nb_context[it1]);
 
       _ALLOC2_VALACK_IN ( in_RETIRE_EVENT_VAL        ,VAL,_param->_nb_front_end, _param->_nb_context[it1]);
       _ALLOC2_VALACK_OUT(out_RETIRE_EVENT_ACK        ,ACK,_param->_nb_front_end, _param->_nb_context[it1]);
       _ALLOC2_SIGNAL_IN ( in_RETIRE_EVENT_STATE      ,"state"             ,Tevent_state_t    ,_param->_size_event_state, _param->_nb_front_end, _param->_nb_context[it1]);
+
+      ALLOC2_INTERFACE_END(_param->_nb_front_end, _param->_nb_context[it1]);
     }
 
@@ -127,30 +136,13 @@
     ALLOC2(internal_RETIRE_EVENT_ACK ,Tcontrol_t,_param->_nb_front_end,_param->_nb_context[it1]);
 
-    rat_gpr                       = new Tgeneral_address_t ** [_param->_nb_front_end];
-    rat_spr                       = new Tspecial_address_t ** [_param->_nb_front_end];
-    rat_gpr_update_table          = new bool               ** [_param->_nb_front_end];
-    rat_spr_update_table          = new bool               ** [_param->_nb_front_end];
-    internal_rat_gpr_update_table = new bool               ** [_param->_nb_front_end];
-    internal_rat_spr_update_table = new bool               ** [_param->_nb_front_end];
+    ALLOC3(rat_gpr                      ,Tgeneral_address_t,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_general_register_logic);
+    ALLOC3(rat_spr                      ,Tspecial_address_t,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_special_register_logic);
+    ALLOC3(rat_gpr_update_table         ,bool              ,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_general_register_logic);
+    ALLOC3(rat_spr_update_table         ,bool              ,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_special_register_logic);
+    ALLOC3(internal_rat_gpr_update_table,bool              ,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_general_register_logic);
+    ALLOC3(internal_rat_spr_update_table,bool              ,_param->_nb_front_end,_param->_nb_context[it1],_param->_nb_special_register_logic);
 
-    for (uint32_t i=0; i<_param->_nb_front_end; i++)
-      {
-	rat_gpr                       [i] = new Tgeneral_address_t * [_param->_nb_context[i]];
-	rat_spr                       [i] = new Tspecial_address_t * [_param->_nb_context[i]];
-	rat_gpr_update_table          [i] = new bool               * [_param->_nb_context[i]];
-	rat_spr_update_table          [i] = new bool               * [_param->_nb_context[i]];
-	internal_rat_gpr_update_table [i] = new bool               * [_param->_nb_context[i]];
-	internal_rat_spr_update_table [i] = new bool               * [_param->_nb_context[i]];
-
-	for (uint32_t j=0; j<_param->_nb_context[i]; j++)
-	  {
-	    rat_gpr                       [i][j] = new Tgeneral_address_t [_param->_nb_general_register_logic];
-	    rat_spr                       [i][j] = new Tspecial_address_t [_param->_nb_special_register_logic];
-	    rat_gpr_update_table          [i][j] = new bool               [_param->_nb_general_register_logic];
-	    rat_spr_update_table          [i][j] = new bool               [_param->_nb_special_register_logic];
-	    internal_rat_gpr_update_table [i][j] = new bool               [_param->_nb_general_register_logic];
-	    internal_rat_spr_update_table [i][j] = new bool               [_param->_nb_special_register_logic];
-	  }
-      }
+    ALLOC1(internal_RETIRE_RESTORE_RD_PHY_OLD,Tcontrol_t,_param->_nb_inst_retire);
+    ALLOC1(internal_RETIRE_RESTORE_RE_PHY_OLD,Tcontrol_t,_param->_nb_inst_retire);
       }
 
